
#include <stdio.h>

// This is a short file to show some
// examples of PC-LINT error/warning
// detection and reporting of common
// errors

/*lint +e716*/  // force lint messages for "while(1) ... " syntax

#define MAX_BUF ( 1024 )
void main()
{
	char buf[MAX_BUF];
	int i;
	for (i = 0; i < MAX_BUF; i++)
	{
		buf[i+1] = 0; // Warning 661: Possible access of out-of-bounds pointer
	}

	char sbuf[1024];
	float fVal;
	float fMax = 100.0;
	int nCount = 0;
	fVal = fMax/nCount; // Warning 414: Possible division by 0
	sprintf(sbuf, "the answer is: %d", fVal); // Warning 559: Size of argument no. 3 inconsistent with format
	sprintf(sbuf, "the answer is: %g for %d", fVal); // Warning 558: Too few arguments for format (1 missing)

	int nRet;
	int nTest = nRet * 10; // Warning 530: Symbol 'nRet' (line 28) not initialized

	int nFoo;
	switch (nTest)
	{
	case 1:
		nFoo = 1;
		break;
	case 2:
		nFoo = 21;
	case 3:			// Info 825: control flows into case/default without -fallthrough comment
		nFoo = 321;
		break;
	}
	int nFooVal = nFoo; // Warning 644: Variable 'nFoo' (line 31) may not have been initialized


	int nTest2 = 0;
	for(;;)
	{
		nTest2++;
		if (nTest2 > nFoo)
			goto done; // Info 801: Use of goto is deprecated
	}
done:

	unsigned int nTest3 = 1;
	while (1) // Info 716: while(1) ... 
	{
		nTest3 = nTest3 << 1;
	}

	//Warning 527: Unreachable

	int nTest4 = 0;
	if (nTest4 == 0) // Info 774: Boolean within 'if' always evaluates to True
	{
	}

	float *fTest;
	int *pInt;
	pInt = (int *) &fTest; // Info 740: Unusual pointer cast (incompatible indirect types)

	unsigned char nByte;
	*pInt = (int *) &nByte; // Info 826: Suspicious pointer-to-pointer conversion (area too small)
}

