
import junit.framework.*;
import net.sourceforge.groboutils.junit.v1.iftc.*;

/**
 * Tests the Sample1 interface.  These tests are in no way
 * exhaustive, but only shown for example.
 */
public class Sample1TestI extends InterfaceTestCase
{
    private static final Class THIS_CLASS = Sample1TestI.class;
    
    public Sample1TestI( String name, ImplFactory f ) {
        super( name, Sample1.class, f );
    }

    protected Sample1 createSample1() {
        return (Sample1)createImplObject();
    }

    //---------------------------------------------------------------
    // Tests
    
    public void testAddString1() {
        Sample1 s1 = createSample1();
        try {
            s1.addString( null );
            fail( "Did not throw IllegalArgumentException." );
        } catch (IllegalArgumentException e) {
            // successfully threw an IllegalArgumentException
        }
    }
    
    public void testAddString2() {
        Sample1 s1 = createSample1();
        s1.addString( "" );
    }
    
    public static InterfaceTestSuite suite() {
        InterfaceTestSuite suite =
            new InterfaceTestSuite( THIS_CLASS );
        return suite;
    }
}

