
import junit.framework.*;
import net.sourceforge.groboutils.junit.v1.iftc.*;

/**
 * Tests the Sample2 abstract class.
 */
public class Sample2TestI extends InterfaceTestCase {
    private static final Class THIS_CLASS = Sample2TestI.class;
    
    public Sample2TestI( String name, ImplFactory f ) {
        super( name, Sample2.class, f );
    }

    protected Sample2 createSample2() {
        return (Sample2)createImplObject();
    }

    //---------------------------------------------------------------
    // Tests
    
    public void testGetAddedStrings1() {
        Sample2 s2 = createSample2();
        s2.addString( "a" );
        java.util.Enumeration enum = s2.getAddedStrings();
        assertNotNull( "Returned null.", enum );
        assertTrue( "Has no added strings.", enum.hasMoreElements() );
        assertEquals( "Not right string.", "a", enum.nextElement() );
        assertTrue( "Has too many added strings.",
            !enum.hasMoreElements() );
    }
    
    
    public static InterfaceTestSuite suite() {
        InterfaceTestSuite suite = Sample1TestI.suite();
        suite.addTestSuite( THIS_CLASS );
        
        return suite;
    }
}

