
import junit.framework.*;
import net.sourceforge.groboutils.junit.v1.iftc.*;

/**
 * Tests the Sample3 interface.
 */
public class Sample3TestI extends InterfaceTestCase {
    private static final Class THIS_CLASS = Sample3TestI.class;
    
    public static interface Sample3Factory {
        public Sample3 create( String[] s );
        public Sample3 create( String s );
    }
    
    public Sample3TestI( String name, ImplFactory f ) {
        super( name, Sample3Factory.class, f );
    }

    protected Sample3Factory createSample3Factory() {
        return (Sample3Factory)createImplObject();
    }

    
    protected Sample3 createSample3( String[] s ) {
        Sample3 s3 = createSample3Factory().create( s );
        assertNotNull( "factory returned null.", s3 );
        return s3;
    }

    protected Sample3 createSample3( String s ) {
        Sample3 s3 = createSample3Factory().create( s );
        assertNotNull( "factory returned null.", s3 );
        return s3;
    }

    //---------------------------------------------------------------
    // Tests
    
    public void testConstructor1() throws Exception {
        Class c = createSample3( "a" ).getClass();
        java.lang.reflect.Constructor cntr = c.getConstructor(
            new Class[] { String[].class } );
        assertNotNull( "Does not contain valid constructor.", cntr );
    }
    
    
    public void testGetStrings1() throws Exception {
        Sample3 s3 = createSample3( "a" );
        String s[] = s3.getStrings();
        assertNotNull( "Null string array.", s );
        assertEquals( "Incorrect array length.", 1, s.length );
        assertEquals( "Returned element incorrect.", "a", s[0] );
    }
    
    
    public void testGetStrings2() throws Exception {
        Sample3 s3 = createSample3( new String[] { "a", "b" } );
        String s[] = s3.getStrings();
        assertNotNull( "Null string array.", s );
        assertEquals( "Incorrect array length.", 2, s.length );
        assertEquals( "Returned element incorrect.", "a", s[0] );
        assertEquals( "Returned element incorrect.", "b", s[1] );
    }
    
    public static InterfaceTestSuite suite() {
        InterfaceTestSuite suite =
            new InterfaceTestSuite( THIS_CLASS );
        return suite;
    }
}

