
import junit.framework.*;
import net.sourceforge.groboutils.junit.v1.iftc.*;

/**
 * Tests the Sample5Impl class.
 */
public class Sample5ImplTest extends TestCase {
    private static final Class THIS_CLASS = Sample5ImplTest.class;
    
    public Sample5ImplTest( String name ) {
        super( name );
    }

    //---------------------------------------------------------------
    // Tests
    
    public void testConstructor1() {
        new Sample5Impl( (String[])null );
    }
    
    
    public static class Sample3ImplFactory
        implements Sample3TestI.Sample3Factory {
        public Sample3 create( String[] s ) {
            return new Sample5Impl( s );
        }
        
        public Sample3 create( String s ) {
            return new Sample5Impl( new String[] { s } );
        }
    }
    
    
    public static Test suite() {
        TestSuite suite = new TestSuite( THIS_CLASS );
        
        //------
        // These two InterfaceTestSuites will share the same set of
        // factories
        InterfaceTestSuite its = Sample2TestI.suite();
        its.addInterfaceTestSuite( Sample4TestI.suite() );
        its.addFactory( new ImplFactory() {
            public Object createImplObject() {
                return new Sample5Impl();
            }
        } );
        its.addFactory( new ImplFactory() {
            public Object createImplObject() {
                return new Sample5Impl( new String[] { "a", "b" } );
            }
        } );
        suite.addTest( its );
        
        //------
        // This InterfaceTestSuite needs a different kind of factory.
        its = Sample3TestI.suite();
        its.addFactory( new ImplFactory() {
            public Object createImplObject() {
                return new Sample3ImplFactory();
            }
        } );
        suite.addTest( its );
        
        return suite;
    }
    
    public static void main( String[] args ) {
        String[] name = { THIS_CLASS.getName() };
        
        junit.textui.TestRunner.main( name );
    }
}

